//+------------------------------------------------------------------+
//|                                                       EasyBE.mq4 |
//|                                                            Roman |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Roman"
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       BE=18;
extern int       SL=15;
extern int       PT=40;
extern int       BE2=22;
extern int       KamBE=5;
extern int       BE3=100;
extern int       KamBE3=88;

int iBuyOrShort;
int iDigit;
bool boManipulated;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  ObjectCreate("BEsetup", OBJ_LABEL, 0, 0, 0);
  ObjectSet("BEsetup",  OBJPROP_CORNER, 1);
  ObjectSet("BEsetup", OBJPROP_XDISTANCE, 30);
  ObjectSet("BEsetup", OBJPROP_YDISTANCE, 40);
  
  ObjectSetText("BEsetup",BE + " " + BE2 + " " + BE3, 12, "Arial", Blue);
      

//----
   
//----
   return(0);
  }

double PrepoctiNaDouble(int iPips)
{
   double dD;
   dD=iPips;
   if(iDigit==4)
   {
      return (dD/10000);   
   }
   if(iDigit==5)
   { 
      return (dD/10000);
   }
   if(iDigit==2)
   {
      return (dD/100);
   }
   if(iDigit==3)
   {
      return (dD/100);
   }
   if(iDigit==1)
   {
      return (dD/10);
   }   
}

bool JsemVPozici()
{
   bool boVybrano;
   string sSymbol;
   RefreshRates();  
   if(OrdersTotal()==0) return(false);
   else
   {
      for(int iIndex=0;iIndex<OrdersTotal();iIndex++)
      {
         boVybrano= OrderSelect(iIndex,SELECT_BY_POS,MODE_TRADES);//Vybrana pozice  
         if ( OrderSymbol()==Symbol()  )
         {
            //sSymbol=OrderSymbol();        
            iDigit=MarketInfo(Symbol(),MODE_DIGITS); 

            iBuyOrShort=OrderType();
            return(true);      
         }
      }   
   }

return(false);
}
double VratPocetPips(double dNumber)
{
   
   if(iDigit==4)
   {
      
      return (dNumber*10000);   
   }
   if(iDigit==5)
   {
      return (dNumber*10000);   
   }

   if(iDigit==2 )
   {
      return (dNumber*100);
   }
   if(iDigit==3 )
   {
      return (dNumber*100);
   }
   if(iDigit==1 )
   {
      return (dNumber*10);
   }

   
   return (1);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("BEsetup");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
    int iProfit=0;
    int iSL;
    int iPT;
    if(JsemVPozici()==true)
    {
    //Print("ffgdfgdf");
      switch(iBuyOrShort)
         {
            case (OP_BUY):
            case(OP_BUYLIMIT):
            case(OP_BUYSTOP):
               
               iProfit=VratPocetPips(NormalizeDouble(Bid-OrderOpenPrice(),iDigit));//+iSpread;
               if(OrderStopLoss()!=0)  iSL=VratPocetPips(NormalizeDouble(OrderOpenPrice()-OrderStopLoss(),iDigit)); else iSL=0;
               iPT=VratPocetPips(NormalizeDouble(OrderTakeProfit()- OrderOpenPrice(),iDigit));

               if(OrderTakeProfit()==0 && OrderStopLoss()==0)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-PrepoctiNaDouble(SL),OrderOpenPrice()+PrepoctiNaDouble(PT),OrderExpiration(),CLR_NONE);               
               }

               if(iProfit>=BE)
               {  
                  
                  if(OrderStopLoss()<OrderOpenPrice() || OrderStopLoss()==0)
                  {
                    Print("Jdu oupat");
                    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration(),CLR_NONE);                                      
                    
                  }                              
               }
               if(iProfit>=BE2)
               {
                  if(OrderStopLoss()<(OrderOpenPrice()+PrepoctiNaDouble(KamBE)) || OrderStopLoss()==0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+PrepoctiNaDouble(KamBE),OrderTakeProfit(),OrderExpiration(),CLR_NONE);
                  }                              
               }
               if(iProfit>=BE3)
               {
                  if(OrderStopLoss()<(OrderOpenPrice()+PrepoctiNaDouble(KamBE3)) || OrderStopLoss()==0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+PrepoctiNaDouble(KamBE3),OrderTakeProfit(),OrderExpiration(),CLR_NONE);
                  }                              
               }
               
            break;
            case (OP_SELL):
            case(OP_SELLLIMIT):
            case(OP_SELLSTOP):
              iProfit=VratPocetPips(NormalizeDouble(OrderOpenPrice()-Ask,iDigit));//-iSpread;            
      //        Print("iProfit " + iProfit);
              if(OrderStopLoss()!=0)  iSL=VratPocetPips(NormalizeDouble(OrderStopLoss()-OrderOpenPrice(),iDigit)); else iSL=0;
              if(OrderTakeProfit()==0 && OrderStopLoss()==0)
              {
                 OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+PrepoctiNaDouble(SL),OrderOpenPrice()-PrepoctiNaDouble(PT),OrderExpiration(),CLR_NONE);                                                      
              }


               if(iProfit>=BE)
               {
                  if(OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0)
                  {
                  Print("Jdu oupat");
                    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration(),CLR_NONE);                  
                  }                              
               }
               if(iProfit>=BE2)
               {
                  if(OrderStopLoss()>(OrderOpenPrice()-PrepoctiNaDouble(KamBE)) || OrderStopLoss()==0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-PrepoctiNaDouble(KamBE),OrderTakeProfit(),OrderExpiration(),CLR_NONE);
                  }                              
               }
               if(iProfit>=BE3)
               {
                  if(OrderStopLoss()>(OrderOpenPrice()-PrepoctiNaDouble(KamBE3)) || OrderStopLoss()==0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-PrepoctiNaDouble(KamBE3),OrderTakeProfit(),OrderExpiration(),CLR_NONE);
                  }                              
               }

            break;         
         }  
        
         OrderSelect(OrderTicket(),SELECT_BY_TICKET );            
    }        
    
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+